package algorithms;

import java.util.Vector;

import main.Main;
import structures.Node;
import structures.Solution;
import structures.Table;
import structures.Zone;

public class AStar extends Algorithm {

	public Solution solve() {
		Vector<Node> frontier = new Vector<Node>();
		long time = System.currentTimeMillis();
		int nodes = 1;
		int cuts = 0;
		Node currentNode;
		Node evaluationNode;
		Table evaluationTable;
		Zone legalMoves;
		frontier.add(0, new Node(Main.table, null, 0, Main.heuristic.calculate(Main.table)));
		while(!frontier.elementAt(0).getStatus() && !logicStop) {
			synchronized(graphicStop) {logicStop = new Boolean(graphicStop);}
			currentNode = frontier.elementAt(0);
			frontier.addElement(frontier.remove(0));
			currentNode.setStatus(true);
			if(goalTest(currentNode.getTable())) 
				return new Solution(currentNode.getLevel(), (int) (System.currentTimeMillis() - time), nodes, cuts);
			legalMoves = Algorithm.legalMoves(currentNode.getTable());
			for(int i = 0; i < legalMoves.getSize(); i++) {
				evaluationTable = (currentNode.getTable()).copy();
				evaluationTable.switchTokens(legalMoves.getZeroLine(), legalMoves.getZeroColumn(), legalMoves.getLine(i), legalMoves.getColumn(i));
				evaluationNode = new Node(evaluationTable, currentNode, currentNode.getLevel() + 1, currentNode.getLevel() + 1 + Main.heuristic.calculate(evaluationTable));
				if(Main.policy.policyCheck(currentNode, evaluationNode)) {
					nodes++;
					currentNode.setSon(evaluationNode);
					int j = 0;
					while(j < frontier.size() && !frontier.elementAt(j).getStatus() && frontier.elementAt(j).getValue() < evaluationNode.getValue()) j++;
					frontier.add(j, evaluationNode);
				}
				else cuts++;
			}
		}
		return new Solution(-1, (int) (System.currentTimeMillis() - time), nodes, cuts);
	}
}
