package algorithms;

import graphics.Ok;
import main.Main;
import structures.Solution;
import structures.Zone;
import structures.Table;

public abstract class Algorithm extends Thread {
	
	protected Boolean graphicStop = new Boolean(false);
	protected Boolean logicStop = new Boolean(false);

	public abstract Solution solve();
	
	public void setGraphicStop(boolean value) {synchronized(graphicStop) {graphicStop = new Boolean(value);}}
	public void setLogicStop(boolean value) {synchronized(graphicStop) {logicStop = new Boolean(graphicStop);}}
	
	public void run() {
		Main.solution = solve();
		Main.wait.disposeForm();
		if(Main.solution.getLevel() != -1) new Ok();
		}
	
	protected boolean goalTest(Table table) {
		for(int i = 0; i < table.getSize(); i++) {
			for(int j = 0; j < table.getSize(); j++) {
				if(table.getElement(i, j) != (i * table.getSize() + j)) return false;
		}
		}
		return true;
	}
	
	public static Zone legalMoves(Table table) {
		int i;
		int j = 0;
		boolean done = false;
		for(i = 0; i < table.getSize() && !done; i++) {
			for(j = 0; j < table.getSize() && !done; j++) if(table.getElement(i, j) == 0) done = true;
		}
		i = i - 1;
		j = j - 1;
		Zone legalZones = new Zone(i, j);
		done = false;
		if(i == 0 && j == 0) {
			done = true;
			legalZones.addToken(i + 1, j);
			legalZones.addToken(i, j + 1);
		}
		if(!done && i == (table.getSize() - 1) && j == (table.getSize() - 1)) {
			done = true;
			legalZones.addToken(i - 1, j);
			legalZones.addToken(i, j - 1);
		}
		if(!done && i == 0 && (j == table.getSize() - 1)) {
			done = true;
			legalZones.addToken(i + 1, j);
			legalZones.addToken(i, j - 1);
		}
		if(!done && i == (table.getSize() - 1) && j == 0) {
			done = true;
			legalZones.addToken(i - 1, j);
			legalZones.addToken(i, j + 1);
		}
		if(!done && i == 0) {
			done = true;
			legalZones.addToken(i + 1, j);
			legalZones.addToken(i, j - 1);
			legalZones.addToken(i, j + 1);
		}
		if(!done && i == (table.getSize() - 1)) {
			done = true;
			legalZones.addToken(i - 1, j);
			legalZones.addToken(i, j - 1);
			legalZones.addToken(i, j + 1);
		}
		if(!done && j == 0) {
			done = true;
			legalZones.addToken(i, j + 1);
			legalZones.addToken(i - 1, j);
			legalZones.addToken(i + 1, j);
		}
		if(!done && j == (table.getSize() - 1)) {
			done = true;
			legalZones.addToken(i, j - 1);
			legalZones.addToken(i - 1, j);
			legalZones.addToken(i + 1, j);
		}
		if(!done) {
			legalZones.addToken(i, j - 1);
			legalZones.addToken(i, j + 1);
			legalZones.addToken(i - 1, j);
			legalZones.addToken(i + 1, j);
		}
		return legalZones;
	}
}
