package graphics;

import heuristics.Manhattan;
import heuristics.Mismatch;
import heuristics.Pitagora;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JSplitPane;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import javax.swing.BoxLayout;
import javax.swing.JTextField;
import java.awt.Insets;
import javax.swing.JComboBox;
import policies.Free;
import policies.Loose;
import policies.Strict;
import algorithms.AStar;
import algorithms.Greedy;
import algorithms.IDAStar;
import structures.Table;
import main.Main;

public class Configuration {

	private JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="138,16"
	private JPanel jContentPane = null;
	private JSplitPane jSplitPane = null;
	private JMenuBar jJMenuBar = null;
	private JMenu jMenu = null;
	private JSplitPane jSplitPane1 = null;
	private JMenuItem jMenuItem = null;
	private JMenuItem jMenuItem1 = null;
	private JMenu jMenu1 = null;
	private JMenuItem jMenuItem2 = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel3 = null;
	private JLabel jLabel1 = null;
	private JTextField jTextField = null;
	private JTextField jTextField1 = null;
	private JLabel jLabel5 = null;
	private JComboBox jComboBox = null;
	private JComboBox jComboBox1 = null;
	private JComboBox jComboBox2 = null;
	private JMenu jMenu2 = null;
	private JMenuItem jMenuItem3 = null;
	private JMenuItem jMenuItem4 = null;
	private JPanel jPanel = null;
	private JPanel jPanel2 = null;
	private JLabel jLabel = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel21 = null;
	private JLabel jLabel22 = null;
	private JLabel jLabel221 = null;
	private JLabel jLabel222 = null;
	private JLabel jLabel223 = null;
	private int algorithmMemo = 0;
	private int heuristicMemo = 0;
	private int policyMemo = 0;
	
	public void enableSolution() {jMenuItem4.setEnabled(true);}
	public JFrame getFrame() {return jFrame;}
	
	public Configuration() {
		getJFrame().setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		jFrame.setResizable(false);
		jFrame.setLocation(400, 300);
		jMenuItem4.setEnabled(false);
		}
	
	/**
	 * This method initializes jFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setSize(new Dimension(403, 199));
			jFrame.setTitle("Puzzle Solver");
			jFrame.setJMenuBar(getJJMenuBar());
			jFrame.setContentPane(getJContentPane());
			jFrame.setVisible(true);
		}
		return jFrame;
	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJSplitPane(), BorderLayout.SOUTH);
			jContentPane.add(getJSplitPane1(), BorderLayout.NORTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jSplitPane	
	 * 	
	 * @return javax.swing.JSplitPane	
	 */
	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane();
			jSplitPane.setRightComponent(getJPanel3());
			jSplitPane.setLeftComponent(getJPanel2());
		}
		return jSplitPane;
	}

	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getJMenu1());
			jJMenuBar.add(getJMenu2());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu();
			jMenu.setText("Table");
			jMenu.add(getJMenuItem());
			jMenu.add(getJMenuItem1());
		}
		return jMenu;
	}

	/**
	 * This method initializes jSplitPane1	
	 * 	
	 * @return javax.swing.JSplitPane	
	 */
	private JSplitPane getJSplitPane1() {
		if (jSplitPane1 == null) {
			jSplitPane1 = new JSplitPane();
			jSplitPane1.setRightComponent(getJPanel1());
			jSplitPane1.setLeftComponent(getJPanel());
		}
		return jSplitPane1;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem() {
		if (jMenuItem == null) {
			jMenuItem = new JMenuItem();
			jMenuItem.setText("Create Table");
			jMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Main.table = new Table(Integer.parseInt(jTextField.getText()));
					Main.table.randomize(Integer.parseInt(jTextField1.getText()));
				}
			});
		}
		return jMenuItem;
	}

	/**
	 * This method initializes jMenuItem1	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem1() {
		if (jMenuItem1 == null) {
			jMenuItem1 = new JMenuItem();
			jMenuItem1.setText("Show Table");
			jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {new Grid();}
			});
		}
		return jMenuItem1;
	}

	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new JMenu();
			jMenu1.setText("Solver");
			jMenu1.add(getJMenuItem2());
		}
		return jMenu1;
	}

	/**
	 * This method initializes jMenuItem2	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem2() {
		if (jMenuItem2 == null) {
			jMenuItem2 = new JMenuItem();
			jMenuItem2.setText("Create Solver");
			jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					algorithmMemo = jComboBox1.getSelectedIndex();
					heuristicMemo = jComboBox.getSelectedIndex();
					policyMemo = jComboBox2.getSelectedIndex();
				}
			});
		}
		return jMenuItem2;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jLabel1 = new JLabel();
			jLabel1.setText(" ");
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BoxLayout(getJPanel1(), BoxLayout.Y_AXIS));
			jPanel1.add(jLabel1, null);
			jPanel1.add(getJTextField(), null);
			jPanel1.add(getJTextField1(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jLabel5 = new JLabel();
			jLabel5.setText(" ");
			jPanel3 = new JPanel();
			jPanel3.setLayout(new BoxLayout(getJPanel3(), BoxLayout.Y_AXIS));
			jPanel3.add(jLabel5, null);
			jPanel3.add(getJComboBox1(), null);
			jPanel3.add(getJComboBox(), null);
			jPanel3.add(getJComboBox2(), null);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setText("3");
		}
		return jTextField;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setText("100");
		}
		return jTextField1;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
			jComboBox = new JComboBox();
			jComboBox.addItem("Mismatch");
			jComboBox.addItem("Pitagora");
			jComboBox.addItem("Manhattan");
		}
		return jComboBox;
	}

	/**
	 * This method initializes jComboBox1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox1() {
		if (jComboBox1 == null) {
			jComboBox1 = new JComboBox();
			jComboBox1.addItem("Greedy");
			jComboBox1.addItem("A*");
			jComboBox1.addItem("IDA*");
		}
		return jComboBox1;
	}

	/**
	 * This method initializes jComboBox2	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox2() {
		if (jComboBox2 == null) {
			jComboBox2 = new JComboBox();
			jComboBox2.addItem("GrandFather");
			jComboBox2.addItem("Ancestors");
			jComboBox2.addItem("Tree");
		}
		return jComboBox2;
	}

	/**
	 * This method initializes jMenu2	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu2() {
		if (jMenu2 == null) {
			jMenu2 = new JMenu();
			jMenu2.setText("Calculate!");
			jMenu2.add(getJMenuItem3());
			jMenu2.add(getJMenuItem4());
		}
		return jMenu2;
	}

	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem3() {
		if (jMenuItem3 == null) {
			jMenuItem3 = new JMenuItem();
			jMenuItem3.setText("Start Calculating");
			jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(algorithmMemo == 0) Main.algorithm = new Greedy();
					if(algorithmMemo == 1) Main.algorithm = new AStar();
					if(algorithmMemo == 2) Main.algorithm = new IDAStar();
					if(heuristicMemo == 0) Main.heuristic = new Mismatch();
					if(heuristicMemo == 1) Main.heuristic = new Pitagora();
					if(heuristicMemo == 2) Main.heuristic = new Manhattan();
					if(policyMemo == 0) Main.policy = new Free();
					if(policyMemo == 1) Main.policy = new Loose();
					if(policyMemo == 2) Main.policy = new Strict();
					Main.algorithm.setGraphicStop(false);
					Main.algorithm.setLogicStop(false);
					Main.wait = new Stop();
					Main.algorithm.start();
				}
			});
		}
		return jMenuItem3;
	}

	/**
	 * This method initializes jMenuItem4	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem4() {
		if (jMenuItem4 == null) {
			jMenuItem4 = new JMenuItem();
			jMenuItem4.setText("Show Solution");
			jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {new graphics.Solution();}
			});
		}
		return jMenuItem4;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 2;
			jLabel22 = new JLabel();
			jLabel22.setText("  Randomize Factor:");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(3, 0, 3, 0);
			gridBagConstraints.gridy = 1;
			jLabel21 = new JLabel();
			jLabel21.setText("                        Size:");
			jLabel2 = new JLabel();
			jLabel2.setText("Table Configuration");
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(jLabel2, new GridBagConstraints());
			jPanel.add(jLabel21, gridBagConstraints);
			jPanel.add(jLabel22, gridBagConstraints1);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(0, 0, 5, 0);
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 3;
			jLabel223 = new JLabel();
			jLabel223.setText("                       Policy:");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.insets = new Insets(5, 0, 10, 0);
			gridBagConstraints3.gridy = 2;
			jLabel222 = new JLabel();
			jLabel222.setText("                  Heuristic:");
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.insets = new Insets(0, 0, 6, 0);
			gridBagConstraints2.gridy = 1;
			jLabel221 = new JLabel();
			jLabel221.setText("                Algorithm:");
			jLabel = new JLabel();
			jLabel.setText("Solver Configuration");
			jPanel2 = new JPanel();
			jPanel2.setLayout(new GridBagLayout());
			jPanel2.add(jLabel, gridBagConstraints5);
			jPanel2.add(jLabel221, gridBagConstraints2);
			jPanel2.add(jLabel222, gridBagConstraints3);
			jPanel2.add(jLabel223, gridBagConstraints4);
		}
		return jPanel2;
	}
}
