package graphics;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.JTable;

import main.Main;

import java.awt.FlowLayout;

public class Grid {

	private JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="132,19"
	private JPanel jContentPane = null;
	private JTable jTable = null;
	
	public Grid() {
		getJFrame().setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		jFrame.setResizable(false);
		jFrame.setLocation(400, 300);
		jFrame.setVisible(true);
		jFrame.setSize(new Dimension(jTable.getWidth() + 40, jTable.getHeight() + 40));
	}
	
	/**
	 * This method initializes jFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setSize(new Dimension(394, 186));
			jFrame.setTitle("Table");
			jFrame.setContentPane(getJContentPane());
		}
		return jFrame;
	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new FlowLayout());
			jContentPane.add(getJTable(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTable() {
		if (jTable == null) {
			jTable = new JTable(Main.table.getSize(), Main.table.getSize());
		}
		for(int i = 0; i < Main.table.getSize(); i++) {
			for(int j = 0; j < Main.table.getSize(); j++) {
				jTable.setValueAt(Main.table.getElement(i, j), i, j);
				if(Main.table.getElement(i, j) == 0) jTable.setValueAt(" ", i, j);
			}
		}
		jTable.setEnabled(false);
		return jTable;
	}

}
