package heuristics;

import structures.Table;

public class Manhattan implements Heuristic {
	
	public int calculate(Table table) {
		int manhattan = 0;
		boolean match;
		for (int i = 0; i < table.getSize(); i++) {
			for (int j = 0; j < table.getSize(); j++) { 
				match = false;
				for(int m = 0; m < table.getSize() && !match; m++) {
					for(int n = 0; n < table.getSize() && !match; n++) {
						if(table.getElement(m, n) == (i * table.getSize() + j)) {
							match = true;
							manhattan = manhattan + Math.abs(m - i) + Math.abs(n - j);
						}
					}
				}
			}
		}
		return manhattan;
	}
}
