package heuristics;

import structures.Table;

public class Pitagora implements Heuristic {

	public int calculate(Table table) {
		int pitagora = 0;
		boolean match;
		for (int i = 0; i < table.getSize(); i++) {
			for (int j = 0; j < table.getSize(); j++) { 
				match = false;
				for(int m = 0; m < table.getSize() && !match; m++) {
					for(int n = 0; n < table.getSize() && !match; n++) {
						if(table.getElement(m, n) == (i * table.getSize() + j)) {
							match = true;
							pitagora = pitagora + (int) Math.floor(Math.sqrt(Math.pow(m - i, 2) + Math.pow(n - j, 2)));
						}
					}
				}
			}
		}
		return pitagora;
	}
}
