package policies;

import structures.Node;

public class Strict implements Policy {

	public boolean policyCheck(Node host, Node guest) {
		while(host.getFather() != null) host = host.getFather();
		return recursivePolicyCheck(host, guest); 
	}
	
	private boolean recursivePolicyCheck(Node host, Node guest) {
		if(host.getTable().equals(guest.getTable()) && guest.getLevel() >= host.getLevel()) return false;
		for(int i = 0; i < host.getSonSize(); i++)
			if(!recursivePolicyCheck(host.getSon(i), guest)) return false;
		return true;
	}
}
