package structures;

import algorithms.Algorithm;

public class Table {

	private int table[][];
	private int size;

	public Table(int dim) {
		size = dim;
		table = new int[size][size];
		for(int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++) table[i][j] = i * size + j;
		}
	}

	public void randomize(int random) {
		/*int[] verify = new int[size * size];
		for(int i = 0; i < size * size; i++) verify[i] = i;
		boolean done = false;
		while(!done) {
			done = true;
			for(int i = 0; i < random; i++) {
				int j = (int) (Math.floor(Math.random() * size * size));
				int k = (int) (Math.floor(Math.random() * size * size));
				int transfer = verify[j];
				verify[j] = verify[k];
				verify[k] = transfer;
				}
			int value = 0;
			for(int i = 0; i < size * size - 1; i++) {
				for(int j = i + 1; j < size * size; j++) {
					if(verify[i] > verify[j]) value++;
				}
			}
			if(value % 2 == 1) done = false;
			System.out.println(value);
		}
		for(int i = 0; i < size; i++) {
			for(int j = 0; j < size; j++) {
			table[i][j] = verify[i * size + j];	
			}
			}
		for(int x = 0; x < size; x++) {
			System.out.println(" ");
			for(int y = 0; y < size; y++) {
				System.out.print(table[x][y]);
			}
		}*/
		int j;
		int m = 0;
		int n = 0;
		Zone legalMoves;
		for (int i = 0; i < random; i++) {
			legalMoves = Algorithm.legalMoves(this);
			j = (int) (Math.floor(Math.random() * legalMoves.getSize()));
			switchTokens(m, n, legalMoves.getLine(j), legalMoves.getColumn(j));
			m = legalMoves.getLine(j);
			n = legalMoves.getColumn(j);
		}	
	}

	public void switchTokens(int a, int b, int x, int y) {
		table[a][b] = table[x][y];
		table[x][y] = 0;
	}
	
	public int getElement(int row, int column) {
		return table[row][column];
	}

	public int getSize() {
		return size;
	}

	public boolean equals(Table puzzle) {
		for(int i = 0; i < size; i++) {
			for(int j = 0; j < size; j++) {
				if(this.table[i][j] != puzzle.getElement(i, j)) return false;
				}
		}
		return true;
	}
	
	public Table copy() {
		Table temporaryTable = new Table(this.size);
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++)
				temporaryTable.table[i][j] = table[i][j];
		}
		return temporaryTable;
	}
}
