package structures;

import java.util.Vector;

public class Zone {

	private Vector<Token> tokenBag;
	private int zeroLine;
	private int zeroColumn;
	
	public Zone (int zeroLine, int zeroColumn) {
		this.zeroLine = zeroLine;
		this.zeroColumn = zeroColumn;
		tokenBag = new Vector<Token>();
	}
	
	public int getZeroLine() {return zeroLine;}
	public int getZeroColumn() {return zeroColumn;}
	public void addToken(int i, int j) {tokenBag.addElement(new Token(i, j));}
	public int getLine(int index) {return tokenBag.elementAt(index).getLine();}
	public int getColumn(int index) {return tokenBag.elementAt(index).getColumn();}
	public int getSize() {return tokenBag.size();}
	
	private class Token {
		
		private int line;
		private int column;
		
		public Token(int line, int column) {
			this.line = line;
			this.column = column;
		}
		
		public int getLine() {return line;}
		public int getColumn() {return column;}
	}
	
}
